use std::any::{TypeId, type_name};
use std::mem::*;
use std::fmt::Debug;
//* # See what's behind the primitive datatypes of Rust
//*
//* This Crate shows off, how primitive Types of rust are stored in memory.

fn main() {
    let mut items = Vec::new();
    items.push(true);
    items.push(false);
    dump_type::<bool>(items);
}

fn dump_type<T: Debug + 'static>(items: Vec<T>) {
    println!("Type:\t{}", type_name::<T>());
    println!("\tID:\t{:?}", TypeId::of::<T>());
    println!("\tItems:");
    unsafe {
        for (index, item) in items.iter().enumerate() {
            let pointer = item as *const T;
            let raw_pointer = pointer as *const u8;
            println!("\t{index:02x}\titem:\t{item:?}\n\
                \t\tpointer: {:X?}\n\
                \t\tmemory: {:X?}",
                pointer,
                *raw_pointer,
            );
        }
    }
}
